diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/model/netmap-net-device.cc ns-3.32/src/fd-net-device/model/netmap-net-device.cc
--- ns-3.31/src/fd-net-device/model/netmap-net-device.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/model/netmap-net-device.cc	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,398 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Pasquale Imputato <p.imputato@gmail.com>
+ */
+
+#include "netmap-net-device.h"
+#include "ns3/system-thread.h"
+#include "ns3/uinteger.h"
+#include <sys/ioctl.h>
+#include <unistd.h>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("NetmapNetDevice");
+
+TypeId
+NetDeviceQueueLock::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::NetDeviceQueueLock")
+    .SetParent<NetDeviceQueue> ()
+    .SetGroupName ("Network")
+    .AddConstructor<NetDeviceQueueLock> ();
+  return tid;
+}
+
+NetDeviceQueueLock::NetDeviceQueueLock ()
+{}
+
+NetDeviceQueueLock::~NetDeviceQueueLock ()
+{}
+
+bool
+NetDeviceQueueLock::IsStopped (void) const
+{
+  m_mutex.lock ();
+  bool stopped = NetDeviceQueue::IsStopped ();
+  m_mutex.unlock ();
+  return stopped;
+}
+
+void
+NetDeviceQueueLock::Start (void)
+{
+  m_mutex.lock ();
+  NetDeviceQueue::Start ();
+  m_mutex.unlock ();
+}
+
+void
+NetDeviceQueueLock::Stop (void)
+{
+  m_mutex.lock ();
+  NetDeviceQueue::Stop ();
+  m_mutex.unlock ();
+}
+
+void
+NetDeviceQueueLock::Wake (void)
+{
+  m_mutex.lock ();
+  NetDeviceQueue::Wake ();
+  m_mutex.unlock ();
+}
+
+void
+NetDeviceQueueLock::NotifyQueuedBytes (uint32_t bytes)
+{
+  m_mutex.lock ();
+  NetDeviceQueue::NotifyQueuedBytes (bytes);
+  m_mutex.unlock ();
+}
+
+void
+NetDeviceQueueLock::NotifyTransmittedBytes (uint32_t bytes)
+{
+  m_mutex.lock ();
+  NetDeviceQueue::NotifyTransmittedBytes (bytes);
+  m_mutex.unlock ();
+}
+
+NetmapNetDeviceFdReader::NetmapNetDeviceFdReader ()
+  : m_bufferSize (65536),
+    // Defaults to maximum TCP window size
+    m_nifp (nullptr)
+{}
+
+void
+NetmapNetDeviceFdReader::SetBufferSize (uint32_t bufferSize)
+{
+  NS_LOG_FUNCTION (this << bufferSize);
+  m_bufferSize = bufferSize;
+}
+
+void
+NetmapNetDeviceFdReader::SetNetmapIfp (struct netmap_if *nifp)
+{
+  NS_LOG_FUNCTION (this << nifp);
+  m_nifp = nifp;
+}
+
+FdReader::Data
+NetmapNetDeviceFdReader::DoRead (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  uint8_t *buf = (uint8_t *) malloc (m_bufferSize);
+  NS_ABORT_MSG_IF (buf == 0, "malloc() failed");
+
+  NS_LOG_LOGIC ("Calling read on fd " << m_fd);
+
+  struct netmap_ring *rxring;
+  uint16_t len = 0;
+  uint32_t rxRingIndex = 0;
+
+  // we have a packet in one of the receiver rings
+  // we check for the first non empty receiver ring
+  while (rxRingIndex < m_nifp->ni_rx_rings)
+    {
+      rxring = NETMAP_RXRING (m_nifp, rxRingIndex);
+
+      if (!nm_ring_empty (rxring))
+        {
+          uint32_t i = rxring->cur;
+          uint8_t *buffer = (uint8_t *) NETMAP_BUF (rxring, rxring->slot[i].buf_idx);
+          len = rxring->slot[i].len;
+          NS_LOG_DEBUG ("Received a packet of " << len << " bytes");
+
+          // copy buffer in the destination memory area
+          memcpy (buf, buffer, len);
+
+          // advance the netmap pointers and sync the fd
+          rxring->head = rxring->cur = nm_ring_next (rxring, i);
+
+          ioctl (m_fd, NIOCRXSYNC, NULL);
+
+          break;
+        }
+
+      rxRingIndex++;
+    }
+
+  if (len <= 0)
+    {
+      free (buf);
+      buf = 0;
+      len = 0;
+    }
+  NS_LOG_LOGIC ("Read " << len << " bytes on fd " << m_fd);
+  return FdReader::Data (buf, len);
+}
+
+NS_OBJECT_ENSURE_REGISTERED (NetmapNetDevice);
+
+TypeId
+NetmapNetDevice::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::NetmapNetDevice")
+    .SetParent<FdNetDevice> ()
+    .SetGroupName ("FdNetDevice")
+    .AddConstructor<NetmapNetDevice> ()
+    .AddAttribute ("SyncAndNotifyQueuePeriod",
+                   "The period of time (in number of us) after which the device syncs the netmap ring and notifies queue status.",
+                   UintegerValue (50),
+                   MakeUintegerAccessor (&NetmapNetDevice::m_syncAndNotifyQueuePeriod),
+                   MakeUintegerChecker<uint8_t> ());
+  return tid;
+}
+
+NetmapNetDevice::NetmapNetDevice ()
+{
+  NS_LOG_FUNCTION (this);
+  m_nifp = nullptr;
+  m_nTxRings = 0;
+  m_nTxRingsSlots = 0;
+  m_nRxRings = 0;
+  m_nRxRingsSlots = 0;
+  m_queue = nullptr;
+  m_totalQueuedBytes = 0;
+  m_syncAndNotifyQueueThread = nullptr;
+  m_syncAndNotifyQueueThreadRun = false;
+}
+
+NetmapNetDevice::~NetmapNetDevice ()
+{
+  NS_LOG_FUNCTION (this);
+  m_nifp = nullptr;
+  m_queue = nullptr;
+}
+
+Ptr<FdReader>
+NetmapNetDevice::DoCreateFdReader (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  Ptr<NetmapNetDeviceFdReader> fdReader = Create<NetmapNetDeviceFdReader> ();
+  // 22 bytes covers 14 bytes Ethernet header with possible 8 bytes LLC/SNAP
+  fdReader->SetBufferSize (GetMtu () + 22);
+  fdReader->SetNetmapIfp (m_nifp);
+  return fdReader;
+}
+
+void
+NetmapNetDevice::DoFinishStartingDevice (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_syncAndNotifyQueueThreadRun = true;
+  m_syncAndNotifyQueueThread = Create<SystemThread> (MakeCallback (&NetmapNetDevice::SyncAndNotifyQueue, this));
+  m_syncAndNotifyQueueThread->Start ();
+}
+
+
+void
+NetmapNetDevice::DoFinishStoppingDevice (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_queue->Stop ();
+
+  m_syncAndNotifyQueueThreadRun = false;
+  m_syncAndNotifyQueueThread->Join ();
+  m_syncAndNotifyQueueThread = nullptr;
+}
+
+uint32_t
+NetmapNetDevice::GetBytesInNetmapTxRing ()
+{
+  NS_LOG_FUNCTION (this);
+
+  struct netmap_ring *txring;
+  txring = NETMAP_TXRING (m_nifp, 0);
+
+  int tail = txring->tail;
+
+  // the netmap ring has one slot reserved
+  int inQueue = (m_nTxRingsSlots - 1) - nm_ring_space (txring);
+
+  uint32_t bytesInQueue = 0;
+
+  for (int i = 1; i < inQueue; i++)
+    {
+      bytesInQueue += txring->slot[tail].len;
+      tail++;
+      tail = tail % m_nTxRingsSlots;
+    }
+
+  return bytesInQueue;
+}
+
+void
+NetmapNetDevice::SetNetDeviceQueue (Ptr<NetDeviceQueue> queue)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_queue = queue;
+}
+
+void
+NetmapNetDevice::SetNetmapInterfaceRepresentation (struct netmap_if *nifp)
+{
+  NS_LOG_FUNCTION (this << nifp);
+
+  m_nifp = nifp;
+}
+
+void
+NetmapNetDevice::SetTxRingsInfo (uint32_t nTxRings, uint32_t nTxRingsSlots)
+{
+  NS_LOG_FUNCTION (this << nTxRings << nTxRingsSlots);
+
+  m_nTxRings = nTxRings;
+  m_nTxRingsSlots = nTxRingsSlots;
+}
+
+void
+NetmapNetDevice::SetRxRingsInfo (uint32_t nRxRings, uint32_t nRxRingsSlots)
+{
+  NS_LOG_FUNCTION (this << nRxRings << nRxRingsSlots);
+
+  m_nRxRings = nRxRings;
+  m_nRxRingsSlots = nRxRingsSlots;
+}
+
+int
+NetmapNetDevice::GetSpaceInNetmapTxRing () const
+{
+  NS_LOG_FUNCTION (this);
+
+  struct netmap_ring *txring;
+  txring = NETMAP_TXRING (m_nifp, 0);
+
+  return nm_ring_space (txring);
+}
+
+// This function runs in a separate thread.
+void
+NetmapNetDevice::SyncAndNotifyQueue ()
+{
+  NS_LOG_FUNCTION (this);
+
+  struct netmap_ring *txring = NETMAP_TXRING (m_nifp, 0);
+
+  uint32_t prevTotalTransmittedBytes = 0;
+
+  while (m_syncAndNotifyQueueThreadRun == true)
+    {
+      // we sync the netmap ring periodically.
+      // the traffic control layer can write packets during the period between two syncs.
+      ioctl (GetFileDescriptor (), NIOCTXSYNC, NULL);
+
+      // we need of a nearly periodic notification to queue limits of the transmitted bytes.
+      uint32_t totalTransmittedBytes = m_totalQueuedBytes - GetBytesInNetmapTxRing ();
+      uint32_t deltaBytes = totalTransmittedBytes - prevTotalTransmittedBytes;
+      NS_LOG_DEBUG (deltaBytes << " delta transmitted bytes");
+      prevTotalTransmittedBytes = totalTransmittedBytes;
+      if (m_queue)
+        {
+          m_queue->NotifyTransmittedBytes (deltaBytes);
+
+          if (GetSpaceInNetmapTxRing () >= 32) // WAKE_THRESHOLD
+            {
+              if (m_queue->IsStopped ())
+                {
+                  m_queue->Wake ();
+                }
+            }
+        }
+
+      usleep (m_syncAndNotifyQueuePeriod);
+
+      NS_LOG_DEBUG ("Space in the netmap ring of " << nm_ring_space (txring) << " packets");
+    }
+
+  ioctl (GetFileDescriptor (), NIOCTXSYNC, NULL);
+
+}
+
+ssize_t
+NetmapNetDevice::Write (uint8_t *buffer, size_t length)
+{
+  NS_LOG_FUNCTION (this << buffer << length);
+
+  struct netmap_ring *txring;
+
+  // we use one ring also in case of multiqueue device to perform an accurate flow control on that ring
+  txring = NETMAP_TXRING (m_nifp, 0);
+
+  uint16_t ret = -1;
+
+  if (m_queue->IsStopped ())
+    {
+      // the device queue is stopped and we cannot write other packets
+      return ret;
+    }
+
+  if (!nm_ring_empty (txring))
+    {
+
+      uint32_t i = txring->cur;
+      uint8_t *buf = (uint8_t *) NETMAP_BUF (txring, txring->slot[i].buf_idx);
+
+      memcpy (buf, buffer, length);
+      txring->slot[i].len = length;
+
+      txring->head = txring->cur = nm_ring_next (txring, i);
+
+      ret = length;
+
+      // we update the total transmitted bytes counter and notify queue limits of the queued bytes
+      m_totalQueuedBytes += length;
+      m_queue->NotifyQueuedBytes (length);
+
+      // if there is no room for other packets then stop the queue.
+      if (nm_ring_space (txring) == 0)
+        {
+          m_queue->Stop ();
+        }
+    }
+
+  return ret;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/model/netmap-net-device.h ns-3.32/src/fd-net-device/model/netmap-net-device.h
--- ns-3.31/src/fd-net-device/model/netmap-net-device.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/fd-net-device/model/netmap-net-device.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,220 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Pasquale Imputato <p.imputato@gmail.com>
+ */
+
+#ifndef NETMAP_NET_DEVICE_H
+#define NETMAP_NET_DEVICE_H
+
+#include "ns3/net-device-queue-interface.h"
+#include <mutex>
+#include "fd-net-device.h"
+#include <net/netmap_user.h>
+#include <atomic>
+
+namespace ns3 {
+
+class SystemThread;
+
+/**
+ * \ingroup fd-net-device
+ *
+ * \brief Network device transmission queue with lock
+ *
+ * This class stores information about a single transmission queue
+ * of a network device that is exposed to queue discs. This class extends
+ * the NetDeviceQueue base class by introducing a lock for methods which
+ * require mutual exclusion on data access in emulation.
+ */
+class NetDeviceQueueLock : public NetDeviceQueue
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  NetDeviceQueueLock ();
+  virtual ~NetDeviceQueueLock ();
+
+  /**
+   * Called by the device to start this device transmission queue.
+   * This is the analogous to the netif_tx_start_queue function of the Linux kernel.
+   */
+  virtual void Start (void);
+
+  /**
+   * Called by the device to stop this device transmission queue.
+   * This is the analogous to the netif_tx_stop_queue function of the Linux kernel.
+   */
+  virtual void Stop (void);
+
+  /**
+   * Called by the device to wake the queue disc associated with this
+   * device transmission queue. This is done by invoking the wake callback.
+   * This is the analogous to the netif_tx_wake_queue function of the Linux kernel.
+   */
+  virtual void Wake (void);
+
+  /**
+   * \brief Get the status of the device transmission queue.
+   * \return true if the device transmission queue is stopped.
+   *
+   * Called by queue discs to enquire about the status of a given transmission queue.
+   * This is the analogous to the netif_xmit_stopped function of the Linux kernel.
+   */
+  virtual bool IsStopped (void) const;
+
+  /**
+   * \brief Called by the netdevice to report the number of bytes queued to the device queue
+   * \param bytes number of bytes queued to the device queue
+   */
+  virtual void NotifyQueuedBytes (uint32_t bytes);
+
+  /**
+   * \brief Called by the netdevice to report the number of bytes it is going to transmit
+   * \param bytes number of bytes the device is going to transmit
+   */
+  virtual void NotifyTransmittedBytes (uint32_t bytes);
+
+private:
+  mutable std::mutex m_mutex; //!< Mutex to serialize the operations performed on the queue
+};
+
+/**
+ * \ingroup fd-net-device
+ *
+ * \brief This class performs the actual data reading from the netmap ring.
+ */
+class NetmapNetDeviceFdReader : public FdReader
+{
+public:
+  NetmapNetDeviceFdReader ();
+
+  /**
+   * \brief Set size of the read buffer.
+   * \param bufferSize the size of the read buffer
+   */
+  void SetBufferSize (uint32_t bufferSize);
+
+  /**
+   * \brief Set netmap interface representation.
+   * \param nifp the netmap interface representation
+   */
+  void SetNetmapIfp (struct netmap_if *nifp);
+
+private:
+  FdReader::Data DoRead (void);
+
+  uint32_t m_bufferSize; //!< size of the read buffer
+  struct netmap_if *m_nifp; //!< Netmap interface representation
+};
+
+/**
+ * \ingroup fd-net-device
+ *
+ * \brief a NetDevice to read/write network traffic from/into a netmap file descriptor.
+ *
+ * A NetmapNetDevice object will read and write packets from/to a netmap file descriptor.
+ *
+ */
+class NetmapNetDevice : public FdNetDevice
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  NetmapNetDevice ();
+  virtual ~NetmapNetDevice ();
+
+  /**
+   * \brief Get the number of bytes currently in the netmap transmission ring.
+   * \return the number of bytes in the netmap transmission ring.
+   */
+  uint32_t GetBytesInNetmapTxRing ();
+
+  /**
+   * \brief Get the number of slots currently available in the netmap transmission ring.
+   * \return the number of slots currently available in the netmap transmission ring.
+   */
+  int GetSpaceInNetmapTxRing () const;
+
+  /**
+   * \brief Set the NetDeviceQueue
+   * \param queue the NetDeviceQueue
+   */
+  void SetNetDeviceQueue (Ptr<NetDeviceQueue> queue);
+
+  /**
+   * \brief Set the netmap interface representation
+   * \param nifp the pointer to netmap interface representation
+   */
+  void SetNetmapInterfaceRepresentation (struct netmap_if *nifp);
+
+  /**
+   * \brief Set the netmap transmission rings info
+   * \param nTxRings the number of transmission rings
+   * \param nTxRingsSlots the number of slots for each transmission ring
+   */
+  void SetTxRingsInfo (uint32_t nTxRings, uint32_t nTxRingsSlots);
+
+  /**
+   * \brief Set the netmap receiver rings info
+   * \param nTxRings the number of receiver rings
+   * \param nTxRingsSlots the number of slots for each receiver ring
+   */
+  void SetRxRingsInfo (uint32_t nRxRings, uint32_t nRxRingsSlots);
+
+  /**
+   * \brief The function Writes a packet into the netmap transmission ring.
+   * \param buffer the pointer to packet
+   * \param lenght the packet lenght
+   * \return the number of written bytes
+   */
+  virtual ssize_t Write (uint8_t *buffer, size_t length);
+
+private:
+  Ptr<FdReader> DoCreateFdReader (void);
+  void DoFinishStartingDevice (void);
+  void DoFinishStoppingDevice (void);
+
+  /**
+   * \brief This function syncs netmap ring and notifies netdevice queue.
+   * This function runs in a separate thread.
+   */
+  virtual void SyncAndNotifyQueue ();
+
+  struct netmap_if *m_nifp; //!< Netmap interface representation
+  uint32_t m_nTxRings; //!< Number of transmission rings
+  uint32_t m_nTxRingsSlots; //!< Number of slots in the transmission rings
+  uint32_t m_nRxRings; //!< Number of receiver rings
+  uint32_t m_nRxRingsSlots; //!< Number of slots in the receiver rings
+  Ptr<NetDeviceQueue> m_queue; //!< NetDevice queue
+  uint32_t m_totalQueuedBytes; //!< Total queued bytes
+  Ptr<SystemThread> m_syncAndNotifyQueueThread; //!< Thread used to perform the flow control
+  std::atomic<bool> m_syncAndNotifyQueueThreadRun; //!< Running flag of the flow control thread
+  uint8_t m_syncAndNotifyQueuePeriod; //!< The period of time in us after which the device syncs the netmap ring and notifies queue status
+};
+
+} // namespace ns3
+
+#endif /* NETMAP_NET_DEVICE_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/fd-net-device/wscript ns-3.32/src/fd-net-device/wscript
--- ns-3.31/src/fd-net-device/wscript	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/fd-net-device/wscript	2020-10-06 15:35:43.000000000 -0700
@@ -28,6 +28,42 @@
                                          "File descriptor NetDevice",
                                          True,
                                          "FdNetDevice module enabled")
+
+            # Check if dpdk environment variables are set. Also check if we have correct paths set.
+            env_rte_sdk = os.environ.get('RTE_SDK', '')
+            env_rte_target = os.environ.get('RTE_TARGET', '')
+            have_dpdk_src = env_rte_sdk != '' and env_rte_target != '' and \
+                            os.path.exists(os.path.join(env_rte_sdk, env_rte_target, 'include/rte_eal.h')) and \
+                            os.path.exists(os.path.join(env_rte_sdk, env_rte_target, 'lib/librte_eal.so'))
+
+            have_dpdk_pkg = False
+            if not have_dpdk_src:
+                # Check if libdpdk is installed as package
+                have_dpdk_pkg = conf.check_cfg(package='libdpdk', uselib_store='DPDK',
+                                  args=['--cflags', '--libs'], mandatory=False)
+
+            conf.env['ENABLE_DPDKNETDEV'] = have_dpdk_pkg or have_dpdk_src
+
+            if conf.env['ENABLE_DPDKNETDEV']:
+                # Set DPDK Lib Mode. pkg if the package if installed or src if built from source.
+                dpdk_lib_mode = 'pkg' if have_dpdk_pkg else 'src'
+                conf.env.append_value('DPDK_LIB_MODE', [dpdk_lib_mode])
+                conf.env.append_value('DEFINES', ['HAVE_DPDK_USER_H'])
+                if have_dpdk_pkg:
+                    conf.report_optional_feature("DpdkNetDevice",
+                                                "DPDK NetDevice",
+                                                True,
+                                                "DPDKNetDevice module enabled (from libdpdk)")
+                else:
+                    conf.report_optional_feature("DpdkNetDevice",
+                                                "DPDK NetDevice",
+                                                True,
+                                                "DPDKNetDevice module enabled (from source)")
+            else:
+                conf.report_optional_feature("DpdkNetDevice",
+                                            "DPDK NetDevice",
+                                            False,
+                                            "libdpdk not found, $RTE_SDK and/or $RTE_TARGET environment variable not set or incorrect")
         else:
             conf.report_optional_feature("FdNetDevice", 
                                          "File descriptor NetDevice",
@@ -44,13 +80,26 @@
         blddir = os.path.abspath(os.path.join(conf.bldnode.abspath(), conf.variant))
         dir = os.path.abspath(os.path.join(blddir, "src/fd-net-device"))
         conf.env.append_value('NS3_EXECUTABLE_PATH', dir)
+
+        if conf.env['ENABLE_DPDKNETDEV']:
+            if 'src' in conf.env['DPDK_LIB_MODE']:
+                dpdk_build = os.path.join(os.environ['RTE_SDK'], os.environ['RTE_TARGET'])
+                conf.env.append_value('CXXFLAGS', ['-I' + os.path.join(dpdk_build, 'include'), '-mssse3'])
+                conf.env.append_value('LINKFLAGS', ['-I' + os.path.join(dpdk_build, 'include')])
+                conf.env.append_value('LINKFLAGS', ['-L' + os.path.join(dpdk_build, 'lib')])
+                conf.env.SHLIB_MARKER += ',-lrte_eal,-lrte_ethdev,-lrte_pmd_virtio,-lrte_pmd_e1000,-lrte_pmd_ixgbe,-lrte_pmd_i40e,-lnuma,-ldl,-lrte_mempool,-lrte_mbuf,-lrte_ring,-lrte_kvargs,-lrte_net'
+        else:
+            # Add this module to the list of modules that won't be built
+            # if they are enabled.
+            conf.env['MODULES_NOT_BUILT'].append('dpdk-net-device')
+
     else:
         # Add this module to the list of modules that won't be built
         # if they are enabled.
         conf.env['MODULES_NOT_BUILT'].append('fd-net-device')
 
     # Next, check for whether specialized FdNetDevice features are enabled
-    # such as tap device support, raw socket support, and planetlab
+    # such as tap device support, raw socket support, netmap support, and planetlab
     
     if conf.env['ENABLE_FDNETDEV']:
         conf.env['ENABLE_TAP'] = conf.check_nonfatal(
@@ -84,6 +133,22 @@
                 False,
                 "needs netpacket/packet.h")
 
+        # Enable use of netmap EMU support
+        conf.env['ENABLE_NETMAP_EMU'] = conf.check_nonfatal(
+           header_name='net/netmap_user.h',
+           define_name='HAVE_NETMAP_USER_H') and have_sysioctl and have_netif
+
+        if conf.env['ENABLE_NETMAP_EMU']:
+            conf.report_optional_feature("NetmapFdNetDevice",
+                "Netmap emulation FdNetDevice",
+                True,
+                "Netmap emulation support enabled")
+        else:
+            conf.report_optional_feature("NetmapFdNetDevice",
+                "Netmap emulation FdNetDevice",
+                False,
+                "needs net/netmap_user.h")
+
         # Enable use of PlanetLab TAP helper
         # TODO: How to validate 
         (sysname, nodename, release, version, machine) = os.uname()
@@ -141,6 +206,29 @@
         module.env.append_value("DEFINES", 
            "TAP_DEV_CREATOR=\"%s\"" % (creator.target,))
 
+    if bld.env['ENABLE_DPDKNETDEV']:
+        module.use.append('DPDK')
+        module.source.extend([
+            'helper/dpdk-net-device-helper.cc',
+            'model/dpdk-net-device.cc'
+        ])
+        headers.source.extend([
+            'helper/dpdk-net-device-helper.h',
+            'model/dpdk-net-device.h'
+        ])
+        if 'src' in bld.env['DPDK_LIB_MODE']:
+            # Add DPDK libraries to library path
+            dpdk_build = os.path.join(os.environ['RTE_SDK'], os.environ['RTE_TARGET'])
+            if os.environ.get('LD_LIBRARY_PATH', '') == '':
+                os.environ['LD_LIBRARY_PATH'] = os.path.join(dpdk_build, 'lib')
+            else:
+                os.environ['LD_LIBRARY_PATH'] += ':' + os.path.join(dpdk_build, 'lib')
+            # Add $RTE_SDK/usertools to PATH env
+            if os.environ.get('PATH', '') == '':
+                os.environ['PATH'] = os.path.join(os.environ['RTE_SDK'], 'usertools')
+            else:
+                os.environ['PATH'] += ':' + os.path.join(os.environ['RTE_SDK'], 'usertools')
+
     if bld.env['ENABLE_EMU']:
         module.source.extend([
             'helper/emu-fd-net-device-helper.cc',
@@ -160,6 +248,27 @@
         module.env.append_value("DEFINES", 
            "RAW_SOCK_CREATOR=\"%s\"" % (creator.target,))
 
+    if bld.env['ENABLE_NETMAP_EMU']:
+        module.source.extend([
+            'model/netmap-net-device.cc',
+            'helper/netmap-net-device-helper.cc',
+        ])
+
+        headers.source.extend([
+            'model/netmap-net-device.h',
+            'helper/netmap-net-device-helper.h',
+        ])
+
+        creator = bld.create_suid_program('netmap-device-creator')
+        creator.source = [
+           'helper/netmap-device-creator.cc',
+           'helper/encode-decode.cc',
+           'helper/creator-utils.cc',
+        ]
+
+        module.env.append_value("DEFINES",
+           "NETMAP_DEV_CREATOR=\"%s\"" % (creator.target,))
+
     if bld.env['ENABLE_PLANETLAB']:
         module.source.extend([
             'helper/planetlab-fd-net-device-helper.cc',
